#!/usr/bin/perl
if (! -f 'doc/install.read' ) {
  print("\nIt looks like you haven't read INSTALL yet. Please do so, as \n",
        "installing a program without reading that is unwise.\n",
	"\n\n(Sorry to do this, but some people need to learn. :)\n");
  exit(1);
}

require "src/lib/version.pl";
&usage("desc: Installation and Initial Configuration Script", "noexit");

print("\nWelcome to $x_fpackage $x_version ($x_codename) \n$x_desc...\n",
      "We will try to install $x_package onto your computer, now.\n\n");

$uid = qx(id -u);
chomp $uid;
if ($uid != 0)
{
  print("\nWARNING!!!\n\nThis program most likely will fail unless it is run by root.\n",
        "However, you can run it however you like. please press enter at here to\n",
        "continue program operation, or press Control-C to end program operation.\n",
	"[please press enter here to continue] ");
	<STDIN>;
}

print("\nNO ACTUAL CHANGES WILL BE MADE TO YOUR SYSTEM UNTIL THE END OF THIS PROGRAM.\n\n");

start:
print("Logplay runs from it's own root directory, for simplicity. Therefore,\n",
      "all logplay files will reside in that directory. Please decide what that\n",
      "directory should be.\n",
      "logplay root_dir [/usr/local/logplay/]: ");

$lpdir = <STDIN>;
chomp($lpdir);

if (($lpdir eq "") || (! defined($lpdir)))
{
  $lpdir = "/usr/local/logplay";
}

my $found = 0;
my @bdirlist = ('/usr', '/usr/local', '/usr/share', '/opt', $ENV{HOME}, "$ENV{HOME}/.logplay");
$found = 0;
foreach $tmp (@bdirlist)
{
  foreach $moo ('logplay', 'logplay2')
  {
    if ($lpdir eq "$tmp/$moo")
    {
      $found++;
    }
  }
}
if ($found != 1)
{
  print("\nWARNING: ($found)\n\n",
        "Logplay considers $lpdir to be a Non-Standard Directory. \n",
	"However, This /IS/ A Free program, and it was written under a Free OS, \n",
	"By someone who believes greatly in free software, so I'm not going to \n",
	"put a damper on that freedom. In order for logplay to find itself, we need\n",
	"to create a file called logplay.conf in /etc specifying your Wacko Directory.\n",
	"(Actually, there are other places and names for that file, you can read\n",
	"src/bin/logplayd for an explanation and list of all the locations you can put it.\n",
	"if this is not okay, please type \"restart\" here, and choose to install in a\n",
	"more sane directory. Otherwise, hit enter at This Prompt.\n", "[This Prompt]: ");
	
  my $tmp = <STDIN>;
  chomp $tmp;
  
  #  I'm probably going to go to hell for using goto, but it's easier in this case.
  # Don't worry, there's no goto calls in logplay itself. :)
  goto start if (lc($tmp) eq "restart");
  $createdest = 1;
}

print("Next Question:\n\n");

print("There needs to be a fifo (Named Pipe) made. you can make this with this command:\n",
      "\tmkfifo $lpdir/etc/fifo\n",
      "or, this command:\n",
      "\tmknod $lpdir/etc/fifo p\n", "Or, I can do it for you.\n");
$yn = "x";

while (($yn !~ m/^y/) && ($yn !~ m/^n/))
{
  print("Would you like me to create the system log fifo for you?\n",
        "create fifo? [y/n] ");
  $yn = <STDIN>;
  lc($yn);
  chomp($yn);
}

if ($yn =~ m/^y/)
{
  $createfifo = 1;
}      
print("analyzing syslog.conf...\n");

$sl=qx(cat /etc/syslog.conf | grep "$lpdir/etc/fifo");

if ($sl)
{
  print("It seems that syslog.conf already contains a nice line for us. yay.\n");
}
else
{
  print("Your syslog.conf needs to have the following line added to it:\n");
  print("\t*.*<tab>|$lpdir/etc/fifo\n");
  print("Either you can do it, or i can. would you like me to do it?\n");

  $yn = "x";

  while (($yn !~ m/^y/) && ($yn !~ m/^n/))
  {
    print("Autmatically edit syslog? [y/n] ");
    $yn = <STDIN>;
    lc($yn);
    chomp($yn);
  }
  if ($yn =~ m/^y/)
  { 
    $editsyslog = 1; 
  }
}
$yn = "x";
while (($yn !~ m/^y/) && ($yn !~ m/^n/))
{
  print("In most cases, you will want all files in $lpdir owned by root.root. \n",
  	"Say Y here, unless you are installing and running logplay as a regular\n",
	"user. (NOTE: Some modules, like the network monitor, require logplay be\n",
	"run as root. installation as root.root is recommended.)\n",
        "Install as root.root? [y/n] ");
  $yn = <STDIN>;
  lc($yn);
  chomp($yn);
}

if ($yn =~ m/^n/)
{
  $notroot = 1;
}
		

print("Here are the configuration options we have for you:\n");
print("installation directory: $lpdir\n");
print("Will create /etc/logplay.conf to tell logplay where to find this directory..\n") if $createdest;
print("Create Fifo: ", $createfifo ? "yes" : "no", "\n");
print("edit syslog: ", $editsyslog ? "yes" : "no", "\n");
print("root install: ", $notroot ? "no" : "yes", "\n");
print("\n");

$yn = "x";

while (($yn !~ m/^y/) && ($yn !~ m/^n/))
{
  print("Would you like me to commit all choices and install logplay? \n",
        "Install Now? [y/n] ");
  $yn = <STDIN>;
  lc($yn);
  chomp($yn);
}
if ($yn =~ m/^y/)
{
  &create_uninst(); 
  &install;
  &create_fifo() if $createfifo;
  &edit_syslog() if $editsyslog;
  print("\n\n\nThe only thing not installed is an init script. if you read INSTALL,\n",
  	"You should know why. Please create or modify one to call logplay at bootup like this:\n",
	"\t$lpdir/bin/logplayd\n",
	"\n\n Thank you for installing Logplay. Send me Any Questions to eyez\@babblica.net..\n");
}
else
{
  print("logplay will not be installed. Please Re-Run this script to try again.\n");
}
exit(0);

sub install
{
  system("mkdir -p $lpdir/");
  system("cp -af src/* sounds/ doc/ $lpdir/");
  @list = qx(find '$lpdir');
  chomp(@list);
  chown(0, 0, @list) unless($notroot);
  if ($createdest) 
  {
    open(DEST, ">/etc/logplay.conf");
    print(DEST "LOGPLAYPATH = $lpdir");
    close(DEST);
  }
}

sub create_fifo
{
  system("mknod $lpdir/etc/fifo p");
}
sub edit_syslog
{
  open(SLC, ">>/etc/syslog.conf");
  print(SLC "# $lpdir/etc/fifo is for logplay.\n", "*.*\t|$lpdir/etc/fifo\n");
  close(SLC);
}

sub create_uninst
{
  print("\nCreating an uninstall Utility...\n",
  	" You can call this utility at a later time by running this command:\n",
	"\tperl $lpdir/bin/uninstall.pl\n\n");
  open(UNINST, ">src/bin/uninstall.pl");
  print(UNINST "#!/usr/bin/perl\n", "use File::Copy 'cp';\n",
  		"system('rm -rf $lpdir');\n",
		"cp('/etc/syslog.conf', '/etc/syslog.conf.bak');\n",
  		"open(SLC, '</etc/syslog.conf');\n",
		"open(SL2, '>/etc/syslog.nologplay');\n",
		"while (<SLC>) { print(SL2 \$_) unless m+$lpdir.*fifo+; }\n",
		"close(SLC);\nclose(SL2);\n",
		"cp('/etc/syslog.nologplay', '/etc/syslog.conf');\n",
		"system('rm /etc/syslog.nologplay');\n",
		'my @bdirlist = (\'/usr\', \'/usr/local\', \'/usr/share\', \'/opt\', \'', 
		$ENV{HOME}, '\', \'', "$ENV{HOME}/.logplay", '\');',
		"\n", 'my @list2 = (\'/etc\', \'/etc/logplay\', \'/usr/etc\', \'/usr/local/etc\', @bdirlist);', "\n",
		"my \@list3 = ('logplay.conf', '.logplayconf', 'logplay');\n",
		"foreach \$x (\@list2) {\n foreach \$x2 (\@list3) {\n",
		"  my \$tmp = \"\$x/\$x2\";\n  system(\"rm -f \$tmp \") if ( -f \$tmp );\n",
		" }\n", "}\n","print('$x_fpackage has been fully uninstalled.', \"\\n\");\n");
  close(UNINST);
}
