&new_func_name('load_mods', 'print_loaded_funtions', 'new_func_name',
	'new_monitor', 'new_output', 'logplay');
sub load_mods
{
  #
  #  This will load all modules in the directory specified in the args.
  # Example: load_mods("$base_dir/modules/input/");
  # Admittedly, they're just perl functions to be loaded, but still.
  #
  my $mod_dir = shift;
  #my $ls = qx(/bin/ls $mod_dir);
  my $file = "$mod_dir/conf";
  open(FICKY, $file);
  my @mods = <FICKY>;
  close(FICKY); 
  foreach (@mods)
  {
    chomp;
    s/\s*#.*//;
    next unless length; # If the module is commented out, we don't load it.
    require "$mod_dir/$_"; # use this module
  }
}

sub print_loaded_functions
{
  #  this is here for debugging purposes.
  # it should not be used with a working logplay installation.
  $debug && print ("Loaded Functions:\n");
  my $loaded;
  foreach $loaded (sort(@func_list))
  {
    $debug && print (" - $loaded\n");
  }
  $debug && print ("Loaded Monitor Modules:\n");
  foreach $loaded (sort(@monitor_list))
  {
    $debug && print (" - $loaded\n");
  }
  $debug && print ("\n");
}

sub new_func_name
{
  #  this function is more for internal recordkeeping.
  # get rid of it if you'd like.
  while (my $fname = shift)
  {
    $func_list[$#func_list+1] = $fname;
  }
}

sub new_monitor
{
  #  We require that all monitors declare themselves with this setup,
  # it allows for the setup_modules and other functions to work properly.
  while (my $mname = shift)
  {
    $monitor_list[$#monitor_list+1] = $mname;
  }
}  
sub new_output
{
  while (my $oname = shift)
  {
    $output_list[$#output_list+1] = $oname;
  }
}

sub setup_modules
{
  #  This runs the monitor_modulename_setup function for each loaded
  #  module. This is why modules are required to declare themselves.
  foreach $mon (sort(@_))
  {
    {
      local $setup = "module_" . $mon . "_setup";
      &$setup();
      $debug && print(" Setup: Module $mon Setup loaded.\n");
    }
  }
}

sub unsetup_modules
{
  #  This runs the monitor_modulename_unsetup function for each loaded
  #  module. This is why modules are required to declare themselves.
  # currently we don't use this.
  foreach $mon (sort(@_))
  {
    {
      local $setup = "module_" . $mon . "_unsetup";
      &$setup();
      $debug && print(" unSetup: Module $mon has been un-setup..\n");
    }
  }
}

sub check_control
{
  #  logplay can check for files in $etc_dir and kill itself,
  # or even restart itself. 
  if ( -f "$etc_dir/kill")
  {
    system("rm -f $etc_dir/kill");
    &unsetup_modules(sort(@monitor_list));
    exit(0);
  }
  if ( -f "$etc_dir/reload" )
  {
    system("rm -f $etc_dir/reload");
    &unsetup_modules(sort(@monitor_list));
    exec("$0");
  }
}
sub go_daemon
{
  $pp=(fork());
  exit(0) if ($pp);
}

sub check_args
{
  foreach (@ARGV)
  {
    &usage if ((m/version/)||(m/-v/));
    &usage("usage ::: -d\tShow Debugging output and Don't Daemonnize::: -h\tShow Help ::: -v\tshow version") if ((m/help/)||(m/-h/));
    $debug = 1 if ((m/debug/)||(m/-d/));
    
  }
}

sub logplay
{
  my $soundtype = lc(shift);
  
  my $soundfile = shift;
  my $sound_used = 0;
  $debug && print("logplay() got soundtype: .$soundtype.\nlogplay() got Sound: .$soundfile.\n");
  foreach $out_file (@output_list)
  {
    if ($soundtype eq $out_file) 
    {
      $sound_used++;
      my $playsub = "$soundtype" . "_play";
      $debug && print("running &$playsub($soundfile);\n");
      &$playsub($soundfile);
    }
  }
  if ($sound_used == 0)
  {
    open(TMPOUT, ">>$etc_dir/logplay_exit_output");
    print(TMPOUT "$sountype / $soundfile ::: Couldn't play. Get help.\n");
    close(TMPOUT);
    $sound_used++;
  }
}

return 1;
