&new_monitor('network');
use Net::Ping;

sub module_network_setup
{
  $cfgfile = "$etc_dir/network.conf";
  $net_proto = "icmp";
  $net_timeout = 2;
  $net_bytes = 1;
  $net_host = "10.0.0.1";
  $net_up = "wav ::: b-e-n-d-e-r.wav";
  $net_down = "wav ::: coming_down.wav";
  
  open(NETCONF, $cfgfile);
  while (<NETCONF>)
  {
    next if m/^#/;
    if (m/^p.*?=\s*(.*)\s*$/)
    {
      $net_proto = $1;
    } 
    elsif (m/^t.*?=\s*(.*)\s*$/)
    {
      $net_timeout = $1;
    }
    elsif (m/^b.*?=\s*(.*)\s*$/)
    {
      $net_bytes = $1;
    }
    elsif (m/^h.*?=\s*(.*)\s*$/)
    {
      $net_host = $1;
    }
    elsif (m/up :::\s+(.*)\s*$/)
    {
      $net_upsound = $1;
    }
    elsif (m/down :::\s+(.*)\s*$/)
    {
      $net_downsound = $1;
    }
  }
  close(NETCONF);
 
  $ping = Net::Ping->new($net_proto, $net_timeout, $net_bytes);
}


sub event_get_network 
{
  my $stype, $sound;
  if ($ping->ping($net_host)) { $net_alive = 0;} else { $net_alive = 1; }
  if ($net_alive == $net_lalive) 
  {
    ($stype, $sound) = "NONE","NONE";
  }
  else
  {
    if ($net_alive == 1)
    {
      ($stype, $sound) = split(/ ::: /, $net_upsound);
    }
    else
    {
      ($stype, $sound) = split(/ ::: /, $net_downsound);
    }
  }
  &logplay($stype, $sound) if ($stype ne "NONE");
}

return(1);
