&new_monitor('syslog');

sub event_get_syslog
{
  #
  #  This function reads from the syslog for us.
  # Well, the fifo that the syslog pipes to.
  my $ret;
  #
  # PseudoCode!!!! yay!
  # +  if we can read a value from the syslog fifo
  # +    then we send that value.
  # +  else
  # +    we send the value 'SKIP'
  #
  #  (we'll have event_parse_syslog skip a SKIP)
  while (1)
  {
    if (my $tmpret = &fakeread)
    {
      $ret = $tmpret;
    } else {
      $ret = "SKIP";
    }
    $ret = "SKIP" if ($ret eq ""); 
    #return($ret);
    last if ($ret eq "SKIP");
    &event_parse_syslog($ret)
  }
}
sub event_parse_syslog
{
  my $syslog_out = shift;
  chomp($syslog_out);
  my ($month,$day,$time,$host,@message) = split(' ', $syslog_out);
  my $message = join(' ', @message);
  $debug && print("thingy: $syslog_out\n");
   
  my ($stype, $sound) = &module_syslog_output($host, $message);
  &logplay($stype, $sound);
}
sub module_syslog_setup
{
  #
  #  First we need to open our fifo in 'non-blocking' mode.
  # This stops logplay from sitting to wait for input on it on the
  # '$tmpret = <FIFO>' above, and instead return an 'undefined' value
  # if no input is waiting on the fifo.
  #
  #  For some reason it still complains if the fifo doesn't have anything 
  # inside it when it calls sysopen(), so we run system() and put something 
  # there. FiFo's are funky creatures.
  $fifo="$base_dir/etc/fifo";
  
  # prevents ugliness on startup, yet doesn't hurt anything in the fifo.
  # system("echo SKIP >> $fifo &"); 
  sysopen(FIFO, $fifo, O_NONBLOCK);
}
sub module_syslog_unsetup
{
  close(FIFO);
}
sub module_syslog_output
{
  my $stypa = $souna = "";
  my $host = shift;
  if ($host ne "")
  {
    my $message = shift;
    $debug && print("Host: $host\nMessage: $message\n");
    my $fname = "$etc_dir/syslog/host.$host";
    if ( ! -f $fname ) 
    {
      $fname = "$etc_dir/syslog/host.generic";
    }
    open(HOSTCONF, $fname);
    while (<HOSTCONF>)
    {
      chomp;
      my ($rxp, $stype, $sound) = split(" ::: ", $_);
      if ($message =~ /$rxp/)
      {
        $stypa = $stype;
        $souna = $sound;
	last;
      }
      else
      {
        $stypa = $souna = "NONE";
      }
    }
  } else { $stypa = $souna = "NONE"; }
  return($stypa, $souna);
}
sub fakeread
{
  #my $fhan = shift;
  $debug && print "trying to read from FIFO\n";
  $buf = $msg = "";
  # my $done = 0;
  #sleep(1);
  while (1) 
  {
    $bytes_read = sysread(FIFO, $buf, 1);
    if (defined($bytes_read)) {
      if ($bytes_read == 0) {
        # Remote socket closed connection
	$debug && print("we lost our fifo.\n");
        close(FIFO);
        last;
      } else {
        if ($buf eq "\n")
	{
	  last;
	} else {
	  $msg .= $buf;
	}
	
      }
    } else {
      last;
    }
  }
  return($msg);
}
return 1;
